#include "4uhv.h"
// cumbia
#include <cumbiapool.h>
#include <cuthreadfactoryimpl.h>
#include <qthreadseventbridgefactory.h>
// cumbia

#include <quapplication.h>
#include <X11/Xlib.h>
#include <QX11Info>

int main(int argc, char *argv[])
{

//     TApplication qu_app( argc, argv );
    QuApplication qu_app( argc, argv );//	TApplication is mapped into QuApplication. DBus connection is provided by cumbia dbus plugin	//	 ## added by qumbiaprojectwizard
    qu_app.setOrganizationName("-");
    qu_app.setApplicationName("-");
    qu_app.setProperty("author", "Giacomo");
    qu_app.setProperty("mail", "giacomo.strangolino@elettra.eu");
    qu_app.setProperty("phone", "0403758073");
    qu_app.setProperty("office", "T2Pt025");
    qu_app.setProperty("hwReferent", "-"); /* name of the referent that provides the device server */

    CumbiaPool *cu_p = new CumbiaPool();
    FourUHV *w = new FourUHV(cu_p, 0);
    if (qu_app.arguments().size() > 1)
        w->setWindowTitle(qu_app.arguments()[1].split('/').last());
    w->show();
    Display *disp = QX11Info::display();
    Window root_win = (Window) w->winId();
    XSetCommand(disp, root_win, argv, argc);
    int ret = qu_app.exec();
    // delete resources and return
    delete w;
    for(std::string n : cu_p->names())
        if(cu_p->get(n))
            delete cu_p->get(n);
    return ret;
}

